// This program is designed for STR-P711 Board.
// It shows how to read/write MMC card

#include "system.h"
#include "mmc.h"
#include <iostr711.h>
#include <string.h>

//it's a simple delay
void Delay (unsigned long a) { while (--a!=0); }

//external buffer for read/write
extern char mmc_buffer[512];
char mmc_buffer_test_1[512];
char mmc_buffer_test_2[512];

//state variable
char state_mmc  = 1;

int main()
{

  // Init frecuency
  FreqInit();

  // System init
  SysInit();


  /**** MMC ****/
  if (initMMC() == MMC_SUCCESS)	// card found
  {
    // fill buffer
    memset(mmc_buffer,0,512);
    memset(mmc_buffer_test_1,'0',512);
    memset(mmc_buffer_test_2,'1',512);
    mmcReadRegister (10, 16);
    mmc_buffer[7]=0;

    // Fill first Block (0) with '0'
    memset(mmc_buffer,'0',512);
    mmcWriteBlock(0);

    // Fill second Block (1)-AbsAddr 512 with '1'
    memset(mmc_buffer,'1',512);
    mmcWriteBlock(512);

    // Read Block(0) back to buffer
    memset(mmc_buffer,0x00,512);           // clear buffer
    mmcReadBlock(0,512);                    // read first block
    // check
    if(strncmp(&mmc_buffer[0], &mmc_buffer_test_1[0], 512)) state_mmc=0;

    // Read Block(1) back to buffer
    memset(mmc_buffer,0x00,512);           // clear buffer
    mmcReadBlock(512,512);                  // read second block
    // check
    if(strncmp(&mmc_buffer[0], &mmc_buffer_test_2[0], 512)) state_mmc=0;


    // report
    if (state_mmc==0) {
       // event for error
    }
    else {
      // event for correctly check
    }
  }

  // loop forever
  while(1) {

  }

}
